diff --git a/lib/librte_eal/common/eal_common_options.c b/lib/librte_eal/common/eal_common_options.c
index 4009f02..7a5d55e 100644
--- a/lib/librte_eal/common/eal_common_options.c
+++ b/lib/librte_eal/common/eal_common_options.c
@@ -297,56 +297,56 @@ eal_parse_common_option(int opt, const char *optarg,
 
 	/* long options */
 	case OPT_NO_HUGE_NUM:
-			conf->no_hugetlbfs = 1;
+		conf->no_hugetlbfs = 1;
 		break;
 
 	case OPT_NO_PCI_NUM:
-			conf->no_pci = 1;
+		conf->no_pci = 1;
 		break;
 
 	case OPT_NO_HPET_NUM:
-			conf->no_hpet = 1;
+		conf->no_hpet = 1;
 		break;
 
 	case OPT_VMWARE_TSC_MAP_NUM:
-			conf->vmware_tsc_map = 1;
+		conf->vmware_tsc_map = 1;
 		break;
 
 	case OPT_NO_SHCONF_NUM:
-			conf->no_shconf = 1;
+		conf->no_shconf = 1;
 		break;
 
 	case OPT_PROC_TYPE_NUM:
-			conf->process_type = eal_parse_proc_type(optarg);
+		conf->process_type = eal_parse_proc_type(optarg);
 		break;
 
 	case OPT_VDEV_NUM:
-			if (rte_eal_devargs_add(RTE_DEVTYPE_VIRTUAL,
-					optarg) < 0) {
-				return -1;
-			}
+		if (rte_eal_devargs_add(RTE_DEVTYPE_VIRTUAL,
+				optarg) < 0) {
+			return -1;
+		}
 		break;
 
 	case OPT_SYSLOG_NUM:
-			if (eal_parse_syslog(optarg, conf) < 0) {
-				RTE_LOG(ERR, EAL, "invalid parameters for --"
-						OPT_SYSLOG "\n");
-				return -1;
-			}
+		if (eal_parse_syslog(optarg, conf) < 0) {
+			RTE_LOG(ERR, EAL, "invalid parameters for --"
+					OPT_SYSLOG "\n");
+			return -1;
+		}
 		break;
 
 	case OPT_LOG_LEVEL_NUM: {
-			uint32_t log;
+		uint32_t log;
 
-			if (eal_parse_log_level(optarg, &log) < 0) {
-				RTE_LOG(ERR, EAL,
-					"invalid parameters for --"
-					OPT_LOG_LEVEL "\n");
-				return -1;
-			}
-			conf->log_level = log;
-		break;
+		if (eal_parse_log_level(optarg, &log) < 0) {
+			RTE_LOG(ERR, EAL,
+				"invalid parameters for --"
+				OPT_LOG_LEVEL "\n");
+			return -1;
 		}
+		conf->log_level = log;
+		break;
+	}
 
 	/* don't know what to do, leave this to caller */
 	default:
diff --git a/lib/librte_eal/linuxapp/eal/eal.c b/lib/librte_eal/linuxapp/eal/eal.c
index 1d468dd..05804dc 100644
--- a/lib/librte_eal/linuxapp/eal/eal.c
+++ b/lib/librte_eal/linuxapp/eal/eal.c
@@ -584,53 +584,53 @@ eal_parse_args(int argc, char **argv)
 
 		/* long options */
 		case OPT_XEN_DOM0_NUM:
-		#ifdef RTE_LIBRTE_XEN_DOM0
-				internal_config.xen_dom0_support = 1;
-		#else
-				RTE_LOG(ERR, EAL, "Can't support DPDK app "
-					"running on Dom0, please configure"
-					" RTE_LIBRTE_XEN_DOM0=y\n");
-				return -1;
-		#endif
+#ifdef RTE_LIBRTE_XEN_DOM0
+			internal_config.xen_dom0_support = 1;
+#else
+			RTE_LOG(ERR, EAL, "Can't support DPDK app "
+				"running on Dom0, please configure"
+				" RTE_LIBRTE_XEN_DOM0=y\n");
+			return -1;
+#endif
 			break;
 
 		case OPT_HUGE_DIR_NUM:
-				internal_config.hugepage_dir = optarg;
+			internal_config.hugepage_dir = optarg;
 			break;
 
 		case OPT_FILE_PREFIX_NUM:
-				internal_config.hugefile_prefix = optarg;
+			internal_config.hugefile_prefix = optarg;
 			break;
 
 		case OPT_SOCKET_MEM_NUM:
-				if (eal_parse_socket_mem(optarg) < 0) {
-					RTE_LOG(ERR, EAL, "invalid parameters for --"
-							OPT_SOCKET_MEM "\n");
-					eal_usage(prgname);
-					return -1;
-				}
+			if (eal_parse_socket_mem(optarg) < 0) {
+				RTE_LOG(ERR, EAL, "invalid parameters for --"
+						OPT_SOCKET_MEM "\n");
+				eal_usage(prgname);
+				return -1;
+			}
 			break;
 
 		case OPT_BASE_VIRTADDR_NUM:
-				if (eal_parse_base_virtaddr(optarg) < 0) {
-					RTE_LOG(ERR, EAL, "invalid parameter for --"
-							OPT_BASE_VIRTADDR "\n");
-					eal_usage(prgname);
-					return -1;
-				}
+			if (eal_parse_base_virtaddr(optarg) < 0) {
+				RTE_LOG(ERR, EAL, "invalid parameter for --"
+						OPT_BASE_VIRTADDR "\n");
+				eal_usage(prgname);
+				return -1;
+			}
 			break;
 
 		case OPT_VFIO_INTR_NUM:
-				if (eal_parse_vfio_intr(optarg) < 0) {
-					RTE_LOG(ERR, EAL, "invalid parameters for --"
-							OPT_VFIO_INTR "\n");
-					eal_usage(prgname);
-					return -1;
-				}
+			if (eal_parse_vfio_intr(optarg) < 0) {
+				RTE_LOG(ERR, EAL, "invalid parameters for --"
+						OPT_VFIO_INTR "\n");
+				eal_usage(prgname);
+				return -1;
+			}
 			break;
 
 		case OPT_CREATE_UIO_DEV_NUM:
-				internal_config.create_uio_dev = 1;
+			internal_config.create_uio_dev = 1;
 			break;
 
 		default: